Index: src/SynTree/Expression.cc
===================================================================
--- src/SynTree/Expression.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Expression.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -52,5 +52,4 @@
 Expression::~Expression() {
 	delete env;
-	delete result;
 }
 
@@ -74,6 +73,4 @@
 ConstantExpr::ConstantExpr( const ConstantExpr &other) : Expression( other ), constant( other.constant ) {
 }
-
-ConstantExpr::~ConstantExpr() {}
 
 void ConstantExpr::print( std::ostream &os, Indenter indent ) const {
@@ -120,8 +117,4 @@
 }
 
-VariableExpr::~VariableExpr() {
-	// don't delete the declaration, since it points somewhere else in the tree
-}
-
 VariableExpr * VariableExpr::functionPointer( FunctionDecl * func ) {
 	VariableExpr * funcExpr = new VariableExpr( func );
@@ -150,9 +143,4 @@
 }
 
-SizeofExpr::~SizeofExpr() {
-	delete expr;
-	delete type;
-}
-
 void SizeofExpr::print( std::ostream &os, Indenter indent) const {
 	os << "Sizeof Expression on: ";
@@ -176,9 +164,4 @@
 }
 
-AlignofExpr::~AlignofExpr() {
-	delete expr;
-	delete type;
-}
-
 void AlignofExpr::print( std::ostream &os, Indenter indent) const {
 	os << "Alignof Expression on: ";
@@ -196,8 +179,4 @@
 UntypedOffsetofExpr::UntypedOffsetofExpr( const UntypedOffsetofExpr &other ) :
 	Expression( other ), type( maybeClone( other.type ) ), member( other.member ) {}
-
-UntypedOffsetofExpr::~UntypedOffsetofExpr() {
-	delete type;
-}
 
 void UntypedOffsetofExpr::print( std::ostream &os, Indenter indent) const {
@@ -217,8 +196,4 @@
 	Expression( other ), type( maybeClone( other.type ) ), member( other.member ) {}
 
-OffsetofExpr::~OffsetofExpr() {
-	delete type;
-}
-
 void OffsetofExpr::print( std::ostream &os, Indenter indent) const {
 	os << "Offsetof Expression on member " << member->name << " of ";
@@ -234,6 +209,4 @@
 OffsetPackExpr::OffsetPackExpr( const OffsetPackExpr &other ) : Expression( other ), type( maybeClone( other.type ) ) {}
 
-OffsetPackExpr::~OffsetPackExpr() { delete type; }
-
 void OffsetPackExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Offset pack expression on ";
@@ -252,10 +225,4 @@
 AttrExpr::AttrExpr( const AttrExpr &other ) :
 		Expression( other ), attr( maybeClone( other.attr ) ), expr( maybeClone( other.expr ) ), type( maybeClone( other.type ) ), isType( other.isType ) {
-}
-
-AttrExpr::~AttrExpr() {
-	delete attr;
-	delete expr;
-	delete type;
 }
 
@@ -280,8 +247,4 @@
 
 CastExpr::CastExpr( const CastExpr &other ) : Expression( other ), arg( maybeClone( other.arg ) ) {
-}
-
-CastExpr::~CastExpr() {
-	delete arg;
 }
 
@@ -306,8 +269,4 @@
 }
 
-VirtualCastExpr::~VirtualCastExpr() {
-	delete arg;
-}
-
 void VirtualCastExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Virtual Cast of:" << std::endl << indent+1;
@@ -332,9 +291,4 @@
 }
 
-UntypedMemberExpr::~UntypedMemberExpr() {
-	delete aggregate;
-	delete member;
-}
-
 void UntypedMemberExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Untyped Member Expression, with field: " << std::endl << indent+1;
@@ -363,9 +317,4 @@
 }
 
-MemberExpr::~MemberExpr() {
-	// don't delete the member declaration, since it points somewhere else in the tree
-	delete aggregate;
-}
-
 void MemberExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Member Expression, with field: " << std::endl;
@@ -383,9 +332,4 @@
 		Expression( other ), function( maybeClone( other.function ) ) {
 	cloneAll( other.args, args );
-}
-
-UntypedExpr::~UntypedExpr() {
-	delete function;
-	deleteAll( args );
 }
 
@@ -436,6 +380,4 @@
 }
 
-NameExpr::~NameExpr() {}
-
 void NameExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Name: " << get_name();
@@ -450,9 +392,4 @@
 LogicalExpr::LogicalExpr( const LogicalExpr &other ) :
 		Expression( other ), arg1( maybeClone( other.arg1 ) ), arg2( maybeClone( other.arg2 ) ), isAnd( other.isAnd ) {
-}
-
-LogicalExpr::~LogicalExpr() {
-	delete arg1;
-	delete arg2;
 }
 
@@ -470,10 +407,4 @@
 ConditionalExpr::ConditionalExpr( const ConditionalExpr &other ) :
 		Expression( other ), arg1( maybeClone( other.arg1 ) ), arg2( maybeClone( other.arg2 ) ), arg3( maybeClone( other.arg3 ) ) {
-}
-
-ConditionalExpr::~ConditionalExpr() {
-	delete arg1;
-	delete arg2;
-	delete arg3;
 }
 
@@ -513,8 +444,4 @@
 ImplicitCopyCtorExpr::~ImplicitCopyCtorExpr() {
 	set_env( nullptr ); // ImplicitCopyCtorExpr does not take ownership of an environment
-	delete callExpr;
-	deleteAll( tempDecls );
-	deleteAll( returnDecls );
-	deleteAll( dtors );
 }
 
@@ -541,8 +468,4 @@
 }
 
-ConstructorExpr::~ConstructorExpr() {
-	delete callExpr;
-}
-
 void ConstructorExpr::print( std::ostream &os, Indenter indent ) const {
 	os <<  "Constructor Expression: " << std::endl << indent+1;
@@ -559,8 +482,4 @@
 
 CompoundLiteralExpr::CompoundLiteralExpr( const CompoundLiteralExpr &other ) : Expression( other ), initializer( other.initializer->clone() ) {}
-
-CompoundLiteralExpr::~CompoundLiteralExpr() {
-	delete initializer;
-}
 
 void CompoundLiteralExpr::print( std::ostream &os, Indenter indent ) const {
@@ -589,13 +508,7 @@
 	cloneAll( other.dtors, dtors );
 }
-StmtExpr::~StmtExpr() {
-	delete statements;
-	deleteAll( dtors );
-	deleteAll( returnDecls );
-}
 void StmtExpr::computeResult() {
 	assert( statements );
 	std::list< Statement * > & body = statements->kids;
-	delete result;
 	result = nullptr;
 	if ( ! returnDecls.empty() ) {
@@ -640,9 +553,5 @@
 UniqueExpr::UniqueExpr( const UniqueExpr &other ) : Expression( other ), expr( maybeClone( other.expr ) ), object( maybeClone( other.object ) ), var( maybeClone( other.var ) ), id( other.id ) {
 }
-UniqueExpr::~UniqueExpr() {
-	delete expr;
-	delete object;
-	delete var;
-}
+
 void UniqueExpr::print( std::ostream &os, Indenter indent ) const {
 	os << "Unique Expression with id:" << id << std::endl << indent+1;
@@ -657,14 +566,7 @@
 InitAlternative::InitAlternative( Type * type, Designation * designation ) : type( type ), designation( designation ) {}
 InitAlternative::InitAlternative( const InitAlternative & other ) : type( maybeClone( other.type ) ), designation( maybeClone( other.designation ) ) {}
-InitAlternative::~InitAlternative() {
-	delete type;
-	delete designation;
-}
 
 UntypedInitExpr::UntypedInitExpr( Expression * expr, const std::list<InitAlternative> & initAlts ) : expr( expr ), initAlts( initAlts ) {}
 UntypedInitExpr::UntypedInitExpr( const UntypedInitExpr & other ) : Expression( other ), expr( maybeClone( other.expr ) ), initAlts( other.initAlts ) {}
-UntypedInitExpr::~UntypedInitExpr() {
-	delete expr;
-}
 
 void UntypedInitExpr::print( std::ostream & os, Indenter indent ) const {
@@ -684,8 +586,4 @@
 }
 InitExpr::InitExpr( const InitExpr & other ) : Expression( other ), expr( maybeClone( other.expr ) ), designation( maybeClone( other.designation) ) {}
-InitExpr::~InitExpr() {
-	delete expr;
-	delete designation;
-}
 
 void InitExpr::print( std::ostream & os, Indenter indent ) const {
@@ -701,7 +599,4 @@
 }
 DeletedExpr::DeletedExpr( const DeletedExpr & other ) : Expression( other ), expr( maybeClone( other.expr ) ), deleteStmt( other.deleteStmt ) {}
-DeletedExpr::~DeletedExpr() {
-	delete expr;
-}
 
 void DeletedExpr::print( std::ostream & os, Indenter indent ) const {
Index: src/SynTree/Expression.h
===================================================================
--- src/SynTree/Expression.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Expression.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -41,5 +41,4 @@
 	ParamEntry( UniqueId decl, Type * actualType, Type * formalType, Expression* expr ): decl( decl ), actualType( actualType ), formalType( formalType ), expr( expr ), inferParams( new InferredParams ) {}
 	ParamEntry( const ParamEntry & other );
-	~ParamEntry();
 	ParamEntry & operator=( const ParamEntry & other );
 
@@ -53,4 +52,7 @@
 /// Expression is the root type for all expressions
 class Expression : public BaseSyntaxNode {
+  protected:
+	virtual ~Expression();
+
   public:
 	Type * result;
@@ -61,5 +63,4 @@
 	Expression();
 	Expression( const Expression & other );
-	virtual ~Expression();
 
 	Type *& get_result() { return result; }
@@ -89,5 +90,4 @@
 	ApplicationExpr( Expression * function, const std::list<Expression *> & args = std::list< Expression * >() );
 	ApplicationExpr( const ApplicationExpr & other );
-	virtual ~ApplicationExpr();
 
 	Expression * get_function() const { return function; }
@@ -111,5 +111,4 @@
 	UntypedExpr( Expression * function, const std::list<Expression *> & args = std::list< Expression * >() );
 	UntypedExpr( const UntypedExpr & other );
-	virtual ~UntypedExpr();
 
 	Expression * get_function() const { return function; }
@@ -136,5 +135,4 @@
 	NameExpr( std::string name );
 	NameExpr( const NameExpr & other );
-	virtual ~NameExpr();
 
 	const std::string & get_name() const { return name; }
@@ -157,5 +155,4 @@
 	AddressExpr( Expression * arg );
 	AddressExpr( const AddressExpr & other );
-	virtual ~AddressExpr();
 
 	Expression * get_arg() const { return arg; }
@@ -176,5 +173,4 @@
 	LabelAddressExpr( const Label &arg );
 	LabelAddressExpr( const LabelAddressExpr & other );
-	virtual ~LabelAddressExpr();
 
 	virtual LabelAddressExpr * clone() const { return new LabelAddressExpr( * this ); }
@@ -192,5 +188,4 @@
 	CastExpr( Expression * arg, Type * toType );
 	CastExpr( const CastExpr & other );
-	virtual ~CastExpr();
 
 	Expression * get_arg() const { return arg; }
@@ -210,5 +205,4 @@
 	VirtualCastExpr( Expression * arg, Type * toType );
 	VirtualCastExpr( const VirtualCastExpr & other );
-	virtual ~VirtualCastExpr();
 
 	Expression * get_arg() const { return arg; }
@@ -229,5 +223,4 @@
 	UntypedMemberExpr( Expression * member, Expression * aggregate );
 	UntypedMemberExpr( const UntypedMemberExpr & other );
-	virtual ~UntypedMemberExpr();
 
 	Expression * get_member() const { return member; }
@@ -251,5 +244,4 @@
 	MemberExpr( DeclarationWithType * member, Expression * aggregate );
 	MemberExpr( const MemberExpr & other );
-	virtual ~MemberExpr();
 
 	DeclarationWithType * get_member() const { return member; }
@@ -272,5 +264,4 @@
 	VariableExpr( DeclarationWithType * var );
 	VariableExpr( const VariableExpr & other );
-	virtual ~VariableExpr();
 
 	DeclarationWithType * get_var() const { return var; }
@@ -292,5 +283,4 @@
 	ConstantExpr( Constant constant );
 	ConstantExpr( const ConstantExpr & other );
-	virtual ~ConstantExpr();
 
 	Constant * get_constant() { return & constant; }
@@ -316,5 +306,4 @@
 	SizeofExpr( const SizeofExpr & other );
 	SizeofExpr( Type * type );
-	virtual ~SizeofExpr();
 
 	Expression * get_expr() const { return expr; }
@@ -341,5 +330,4 @@
 	AlignofExpr( const AlignofExpr & other );
 	AlignofExpr( Type * type );
-	virtual ~AlignofExpr();
 
 	Expression * get_expr() const { return expr; }
@@ -364,5 +352,4 @@
 	UntypedOffsetofExpr( Type * type, const std::string & member );
 	UntypedOffsetofExpr( const UntypedOffsetofExpr & other );
-	virtual ~UntypedOffsetofExpr();
 
 	std::string get_member() const { return member; }
@@ -385,5 +372,4 @@
 	OffsetofExpr( Type * type, DeclarationWithType * member );
 	OffsetofExpr( const OffsetofExpr & other );
-	virtual ~OffsetofExpr();
 
 	Type * get_type() const { return type; }
@@ -405,5 +391,4 @@
 	OffsetPackExpr( StructInstType * type );
 	OffsetPackExpr( const OffsetPackExpr & other );
-	virtual ~OffsetPackExpr();
 
 	StructInstType * get_type() const { return type; }
@@ -427,5 +412,4 @@
 	AttrExpr( const AttrExpr & other );
 	AttrExpr( Expression * attr, Type * type );
-	virtual ~AttrExpr();
 
 	Expression * get_attr() const { return attr; }
@@ -452,5 +436,4 @@
 	LogicalExpr( Expression * arg1, Expression * arg2, bool andp = true );
 	LogicalExpr( const LogicalExpr & other );
-	virtual ~LogicalExpr();
 
 	bool get_isAnd() const { return isAnd; }
@@ -478,5 +461,4 @@
 	ConditionalExpr( Expression * arg1, Expression * arg2, Expression * arg3 );
 	ConditionalExpr( const ConditionalExpr & other );
-	virtual ~ConditionalExpr();
 
 	Expression * get_arg1() const { return arg1; }
@@ -501,5 +483,4 @@
 	CommaExpr( Expression * arg1, Expression * arg2 );
 	CommaExpr( const CommaExpr & other );
-	virtual ~CommaExpr();
 
 	Expression * get_arg1() const { return arg1; }
@@ -521,5 +502,4 @@
 	TypeExpr( Type * type );
 	TypeExpr( const TypeExpr & other );
-	virtual ~TypeExpr();
 
 	Type * get_type() const { return type; }
@@ -541,5 +521,4 @@
 	AsmExpr( Expression * inout, Expression * constraint, Expression * operand ) : inout( inout ), constraint( constraint ), operand( operand ) {}
 	AsmExpr( const AsmExpr & other );
-	virtual ~AsmExpr() { delete inout; delete constraint; delete operand; };
 
 	Expression * get_inout() const { return inout; }
@@ -563,4 +542,7 @@
 /// along with a set of copy constructor calls, one for each argument.
 class ImplicitCopyCtorExpr : public Expression {
+protected:
+	virtual ~ImplicitCopyCtorExpr();
+
 public:
 	ApplicationExpr * callExpr;
@@ -571,5 +553,4 @@
 	ImplicitCopyCtorExpr( ApplicationExpr * callExpr );
 	ImplicitCopyCtorExpr( const ImplicitCopyCtorExpr & other );
-	virtual ~ImplicitCopyCtorExpr();
 
 	ApplicationExpr * get_callExpr() const { return callExpr; }
@@ -593,5 +574,4 @@
 	ConstructorExpr( Expression * callExpr );
 	ConstructorExpr( const ConstructorExpr & other );
-	~ConstructorExpr();
 
 	Expression * get_callExpr() const { return callExpr; }
@@ -611,5 +591,4 @@
 	CompoundLiteralExpr( Type * type, Initializer * initializer );
 	CompoundLiteralExpr( const CompoundLiteralExpr & other );
-	virtual ~CompoundLiteralExpr();
 
 	Initializer * get_initializer() const { return initializer; }
@@ -648,5 +627,4 @@
 	UntypedTupleExpr( const std::list< Expression * > & exprs );
 	UntypedTupleExpr( const UntypedTupleExpr & other );
-	virtual ~UntypedTupleExpr();
 
 	std::list<Expression*>& get_exprs() { return exprs; }
@@ -665,5 +643,4 @@
 	TupleExpr( const std::list< Expression * > & exprs );
 	TupleExpr( const TupleExpr & other );
-	virtual ~TupleExpr();
 
 	std::list<Expression*>& get_exprs() { return exprs; }
@@ -683,5 +660,4 @@
 	TupleIndexExpr( Expression * tuple, unsigned int index );
 	TupleIndexExpr( const TupleIndexExpr & other );
-	virtual ~TupleIndexExpr();
 
 	Expression * get_tuple() const { return tuple; }
@@ -703,5 +679,4 @@
 	TupleAssignExpr( const std::list< Expression * > & assigns, const std::list< ObjectDecl * > & tempDecls );
 	TupleAssignExpr( const TupleAssignExpr & other );
-	virtual ~TupleAssignExpr();
 
 	TupleAssignExpr * set_stmtExpr( StmtExpr * newValue ) { stmtExpr = newValue; return this; }
@@ -723,5 +698,4 @@
 	StmtExpr( CompoundStmt * statements );
 	StmtExpr( const StmtExpr & other );
-	virtual ~StmtExpr();
 
 	CompoundStmt * get_statements() const { return statements; }
@@ -748,5 +722,4 @@
 	UniqueExpr( Expression * expr, long long idVal = -1 );
 	UniqueExpr( const UniqueExpr & other );
-	~UniqueExpr();
 
 	Expression * get_expr() const { return expr; }
@@ -778,5 +751,4 @@
 	InitAlternative( const InitAlternative & other );
 	InitAlternative & operator=( const Initializer & other ) = delete; // at the moment this isn't used, and I don't want to implement it
-	~InitAlternative();
 };
 
@@ -788,5 +760,4 @@
 	UntypedInitExpr( Expression * expr, const std::list<InitAlternative> & initAlts );
 	UntypedInitExpr( const UntypedInitExpr & other );
-	~UntypedInitExpr();
 
 	Expression * get_expr() const { return expr; }
@@ -808,5 +779,4 @@
 	InitExpr( Expression * expr, Designation * designation );
 	InitExpr( const InitExpr & other );
-	~InitExpr();
 
 	Expression * get_expr() const { return expr; }
@@ -830,5 +800,4 @@
 	DeletedExpr( Expression * expr, BaseSyntaxNode * deleteStmt );
 	DeletedExpr( const DeletedExpr & other );
-	~DeletedExpr();
 
 	virtual DeletedExpr * clone() const { return new DeletedExpr( * this ); }
Index: src/SynTree/FunctionDecl.cc
===================================================================
--- src/SynTree/FunctionDecl.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/FunctionDecl.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -52,10 +52,4 @@
 	}
 	cloneAll( other.withExprs, withExprs );
-}
-
-FunctionDecl::~FunctionDecl() {
-	delete type;
-	delete statements;
-	deleteAll( withExprs );
 }
 
Index: src/SynTree/FunctionType.cc
===================================================================
--- src/SynTree/FunctionType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/FunctionType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -31,9 +31,4 @@
 	cloneAll( other.returnVals, returnVals );
 	cloneAll( other.parameters, parameters );
-}
-
-FunctionType::~FunctionType() {
-	deleteAll( returnVals );
-	deleteAll( parameters );
 }
 
Index: src/SynTree/GcTracer.cc
===================================================================
--- src/SynTree/GcTracer.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
+++ src/SynTree/GcTracer.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -0,0 +1,29 @@
+//
+// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
+//
+// The contents of this file are covered under the licence agreement in the
+// file "LICENCE" distributed with Cforall.
+//
+// GcTracer.cc --
+//
+// Author           : Aaron B. Moss
+// Created On       : Thu Mar 15 14:47:00 2018
+// Last Modified By : Aaron B. Moss
+// Last Modified On : Thu Mar 15 14:47:00 2018
+// Update Count     : 1
+//
+
+#include "GcTracer.h"
+
+#include "Expression.h"
+#include "TypeSubstitution.h"
+
+void GcTracer::postvisit( Expression * expr ) {
+
+}
+
+// Local Variables: //
+// tab-width: 4 //
+// mode: c++ //
+// compile-command: "make install" //
+// End: //
Index: src/SynTree/GcTracer.h
===================================================================
--- src/SynTree/GcTracer.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
+++ src/SynTree/GcTracer.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -0,0 +1,62 @@
+//
+// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
+//
+// The contents of this file are covered under the licence agreement in the
+// file "LICENCE" distributed with Cforall.
+//
+// GcTracer.h --
+//
+// Author           : Aaron B. Moss
+// Created On       : Thu Mar 15 14:47:00 2018
+// Last Modified By : Aaron B. Moss
+// Last Modified On : Thu Mar 15 14:47:00 2018
+// Update Count     : 1
+//
+
+#pragma once
+
+#include <list>
+
+#include "BaseSyntaxNode.h"
+#include "Expression.h"
+
+#include "Common/GC.h"
+#include "Common/PassVisitor.h"
+
+class Expression;
+
+/// Implements `trace` method for syntax nodes
+class GcTracer final : public WithShortCircuiting, public WithVisitorRef<GcTracer> {
+	const GC& gc;
+
+public:
+	GcTracer( const GC& gc ) : gc(gc) {}
+
+	void previsit( BaseSyntaxNode * node ) {
+		// skip tree if already seen
+		if ( node->mark == gc.mark ) {
+			visit_children = false;
+			return;
+		}
+
+		// mark node
+		node->mark = gc.mark;
+	}
+
+	void postvisit( Expression* expr ) {
+		maybeAccept( expr->env, *visitor );
+	}
+};
+
+/// Traces entire translation unit recursively
+static inline const GC& operator<< ( const GC& gc, const std::list<Declaration*>& translationUnit ) {
+	PassVisitor<GcTracer> tracer{ gc };
+	acceptAll( translationUnit, tracer );
+	return gc;
+}
+
+// Local Variables: //
+// tab-width: 4 //
+// mode: c++ //
+// compile-command: "make install" //
+// End: //
Index: src/SynTree/Initializer.cc
===================================================================
--- src/SynTree/Initializer.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Initializer.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -32,10 +32,4 @@
 }
 
-Designation::~Designation() {
-	// std::cerr << "destroying designation" << std::endl;
-	deleteAll( designators );
-	// std::cerr << "finished destroying designation" << std::endl;
-}
-
 void Designation::print( std::ostream &os, Indenter indent ) const {
 	if ( ! designators.empty() ) {
@@ -52,5 +46,4 @@
 Initializer::Initializer( const Initializer & other ) : BaseSyntaxNode( other ), maybeConstructed( other.maybeConstructed ) {
 }
-Initializer::~Initializer() {}
 
 SingleInit::SingleInit( Expression *v, bool maybeConstructed ) : Initializer( maybeConstructed ), value ( v ) {
@@ -58,8 +51,4 @@
 
 SingleInit::SingleInit( const SingleInit &other ) : Initializer(other), value ( maybeClone( other.value ) ) {
-}
-
-SingleInit::~SingleInit() {
-	delete value;
 }
 
@@ -87,9 +76,4 @@
 }
 
-ListInit::~ListInit() {
-	deleteAll( initializers );
-	deleteAll( designations );
-}
-
 void ListInit::print( std::ostream &os, Indenter indent ) const {
 	os << "Compound initializer: " << std::endl;
@@ -110,10 +94,4 @@
 ConstructorInit::ConstructorInit( Statement * ctor, Statement * dtor, Initializer * init ) : Initializer( true ), ctor( ctor ), dtor( dtor ), init( init ) {}
 ConstructorInit::ConstructorInit( const ConstructorInit &other ) : Initializer( other ), ctor( maybeClone( other.ctor ) ), dtor( maybeClone( other.dtor ) ), init( maybeClone( other.init ) ) {
-}
-
-ConstructorInit::~ConstructorInit() {
-	delete ctor;
-	delete dtor;
-	delete init;
 }
 
Index: src/SynTree/Initializer.h
===================================================================
--- src/SynTree/Initializer.h	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Initializer.h	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -33,5 +33,4 @@
 	Designation( const std::list< Expression * > & designators );
 	Designation( const Designation & other );
-	virtual ~Designation();
 
 	std::list< Expression * > & get_designators() { return designators; }
@@ -50,5 +49,4 @@
 	Initializer( bool maybeConstructed );
 	Initializer( const Initializer & other );
-	virtual ~Initializer();
 
 	bool get_maybeConstructed() { return maybeConstructed; }
@@ -70,5 +68,4 @@
 	SingleInit( Expression *value, bool maybeConstructed = false );
 	SingleInit( const SingleInit &other );
-	virtual ~SingleInit();
 
 	Expression *get_value() { return value; }
@@ -91,5 +88,4 @@
 			  const std::list<Designation *> &designators = {}, bool maybeConstructed = false );
 	ListInit( const ListInit & other );
-	virtual ~ListInit();
 
 	std::list<Designation *> & get_designations() { return designations; }
@@ -123,5 +119,4 @@
 	ConstructorInit( Statement * ctor, Statement * dtor, Initializer * init );
 	ConstructorInit( const ConstructorInit &other );
-	virtual ~ConstructorInit();
 
 	void set_ctor( Statement * newValue ) { ctor = newValue; }
Index: src/SynTree/NamedTypeDecl.cc
===================================================================
--- src/SynTree/NamedTypeDecl.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/NamedTypeDecl.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -30,10 +30,4 @@
 	cloneAll( other.parameters, parameters );
 	cloneAll( other.assertions, assertions );
-}
-
-NamedTypeDecl::~NamedTypeDecl() {
-	delete base;
-	deleteAll( parameters );
-	deleteAll( assertions );
 }
 
Index: src/SynTree/ObjectDecl.cc
===================================================================
--- src/SynTree/ObjectDecl.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/ObjectDecl.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -32,10 +32,4 @@
 ObjectDecl::ObjectDecl( const ObjectDecl &other )
 	: Parent( other ), type( maybeClone( other.type ) ), init( maybeClone( other.init ) ), bitfieldWidth( maybeClone( other.bitfieldWidth ) ) {
-}
-
-ObjectDecl::~ObjectDecl() {
-	delete type;
-	delete init;
-	delete bitfieldWidth;
 }
 
Index: src/SynTree/PointerType.cc
===================================================================
--- src/SynTree/PointerType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/PointerType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -36,9 +36,4 @@
 }
 
-PointerType::~PointerType() {
-	delete base;
-	delete dimension;
-}
-
 void PointerType::print( std::ostream &os, Indenter indent ) const {
 	Type::print( os, indent );
Index: src/SynTree/ReferenceToType.cc
===================================================================
--- src/SynTree/ReferenceToType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/ReferenceToType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -32,8 +32,4 @@
 ReferenceToType::ReferenceToType( const ReferenceToType &other ) : Type( other ), name( other.name ), hoistType( other.hoistType ) {
 	cloneAll( other.parameters, parameters );
-}
-
-ReferenceToType::~ReferenceToType() {
-	deleteAll( parameters );
 }
 
@@ -170,7 +166,4 @@
 }
 
-TraitInstType::~TraitInstType() {
-}
-
 bool TraitInstType::isComplete() const { assert( false ); }
 
@@ -183,9 +176,4 @@
 
 TypeInstType::TypeInstType( const TypeInstType &other ) : Parent( other ), baseType( other.baseType ), isFtype( other.isFtype ) {
-}
-
-
-TypeInstType::~TypeInstType() {
-	// delete baseType; //This is shared and should not be deleted
 }
 
Index: src/SynTree/ReferenceType.cc
===================================================================
--- src/SynTree/ReferenceType.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/ReferenceType.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -28,8 +28,4 @@
 }
 
-ReferenceType::~ReferenceType() {
-	delete base;
-}
-
 int ReferenceType::referenceDepth() const {
 	return base->referenceDepth()+1;
Index: src/SynTree/Statement.cc
===================================================================
--- src/SynTree/Statement.cc	(revision 61718416c4ecce46bb8d5202cc875d5e197c5cfd)
+++ src/SynTree/Statement.cc	(revision 68f9c43ecf1873cbb5f06aee682704b56612ed16)
@@ -44,13 +44,7 @@
 }
 
-Statement::~Statement() {}
-
 ExprStmt::ExprStmt( Expression *expr ) : Statement(), expr( expr ) {}
 
 ExprStmt::ExprStmt( const ExprStmt &other ) : Statement( other ), expr( maybeClone( other.expr ) ) {}
-
-ExprStmt::~ExprStmt() {
-	delete expr;
-}
 
 void ExprStmt::print( std::ostream &os, Indenter indent ) const {
@@ -66,11 +60,4 @@
   cloneAll( other.input, input );
   cloneAll( other.clobber, clobber );
-}
-
-AsmStmt::~AsmStmt() {
-	delete instruction;
-	deleteAll( output );
-	deleteAll( input );
-	deleteAll( clobber );
 }
 
@@ -122,8 +109,4 @@
 ReturnStmt::ReturnStmt( const ReturnStmt & other ) : Statement( other ), expr( maybeClone( other.expr ) ) {}
 
-ReturnStmt::~ReturnStmt() {
-	delete expr;
-}
-
 void ReturnStmt::print( std::ostream &os, Indenter indent ) const {
 	os << "Return Statement, returning: ";
@@ -141,11 +124,4 @@
 	Statement( other ), condition( maybeClone( other.condition ) ), thenPart( maybeClone( other.thenPart ) ), elsePart( maybeClone( other.elsePart ) ) {
 	cloneAll( other.initialization, initialization );
-}
-
-IfStmt::~IfStmt() {
-	deleteAll( initialization );
-	delete condition;
-	delete thenPart;
-	delete elsePart;
 }
 
@@ -185,10 +161,4 @@
 }
 
-SwitchStmt::~SwitchStmt() {
-	delete condition;
-	// destroy statements
-	deleteAll( statements );
-}
-
 void SwitchStmt::print( std::ostream &os, Indenter indent ) const {
 	os << "Switch on condition: ";
@@ -209,9 +179,4 @@
 	Statement( other ), condition( maybeClone(other.condition ) ), _isDefault( other._isDefault ) {
 	cloneAll( other.stmts, stmts );
-}
-
-CaseStmt::~CaseStmt() {
-	delete condition;
-	deleteAll( stmts );
 }
 
@@ -243,9 +208,4 @@
 }
 
-WhileStmt::~WhileStmt() {
-	delete body;
-	delete condition;
-}
-
 void WhileStmt::print( std::ostream &os, Indenter indent ) const {
 	os << "While on condition: " << endl ;
@@ -265,11 +225,4 @@
 		cloneAll( other.initialization, initialization );
 
-}
-
-ForStmt::~ForStmt() {
-	deleteAll( initialization );
-	delete condition;
-	delete increment;
-	delete body;
 }
 
@@ -311,9 +264,4 @@
 ThrowStmt::ThrowStmt( const ThrowStmt &other ) :
 	Statement ( other ), kind( other.kind ), expr( maybeClone( other.expr ) ), target( maybeClone( other.target ) ) {
-}
-
-ThrowStmt::~ThrowStmt() {
-	delete expr;
-	delete target;
 }
 
@@ -336,10 +284,4 @@
 }
 
-TryStmt::~TryStmt() {
-	delete block;
-	deleteAll( handlers );
-	delete finallyBlock;
-}
-
 void TryStmt::print( std::ostream &os, Indenter indent ) const {
 	os << "Try Statement" << endl;
@@ -370,9 +312,4 @@
 }
 
-CatchStmt::~CatchStmt() {
-	delete decl;
-	delete body;
-}
-
 void CatchStmt::print( std::ostream &os, Indenter indent ) const {
 	os << "Catch " << ((Terminate == kind) ? "Terminate" : "Resume") << " Statement" << endl;
@@ -397,8 +334,4 @@
 
 FinallyStmt::FinallyStmt( const FinallyStmt & other ) : Statement( other ), block( maybeClone( other.block ) ) {
-}
-
-FinallyStmt::~FinallyStmt() {
-	delete block;
 }
 
@@ -434,20 +367,4 @@
 }
 
-WaitForStmt::~WaitForStmt() {
-	for( auto & clause : clauses ) {
-		delete clause.target.function;
-		deleteAll( clause.target.arguments );
-		delete clause.statement;
-		delete clause.condition;
-	}
-
-	delete timeout.time;
-	delete timeout.statement;
-	delete timeout.condition;
-
-	delete orelse.statement;
-	delete orelse.condition;
-}
-
 void WaitForStmt::print( std::ostream &os, Indenter indent ) const {
 	os << "Waitfor Statement" << endl;
@@ -460,8 +377,4 @@
 WithStmt::WithStmt( const WithStmt & other ) : Statement( other ), stmt( maybeClone( other.stmt ) ) {
 	cloneAll( other.exprs, exprs );
-}
-WithStmt::~WithStmt() {
-	deleteAll( exprs );
-	delete stmt;
 }
 
@@ -489,8 +402,4 @@
 }
 
-ImplicitCtorDtorStmt::~ImplicitCtorDtorStmt() {
-	delete callStmt;
-}
-
 void ImplicitCtorDtorStmt::print( std::ostream &os, Indenter indent ) const {
 	os << "Implicit Ctor Dtor Statement" << endl;
